// CotxBluetooth_Polsat
// Copyleft (C) 2019 Carles Ferrando Garcia
// License: GNU GPL v3 http://www.gnu.org/copyleft/gpl.html 
// Cotxe amb un Bluetooth controlat amb un telefon Android


//definim ports motor 1 o motor dret
//Recorda que el Motor 1 el fem girar horariament si activem el pin 8, i el fem girar anti horariament  si activem el pin 9. Si activem el PWM 10 i el motor 1 tindrà una ona quadrada
int contacte1motor1 = 8;    
int contacte2motor1 = 9;    
int activaPWMmotor1 = 10;

//definim ports motor 2 o motor esquerre
// Recorda que el Motor 2 el fem girar horariament si activem el pin 12, i el fem girar anti horariament si si activem el pin 13. Si activem el PWM 11 i el motor 1 tindrà una ona quadrada
int contacte1motor2 = 12;    
int contacte2motor2 = 13;    
int activaPWMmotor2 = 11;

//definim el pols per controlar la velocitat dels motors
int pols=50; // emtre 0% i 100%
float escriuPols= pols/100.0*255.0; //valor que escriura analogwrite al PWM entre 0 i 255
#include <SoftwareSerial.h>
 
SoftwareSerial serial(2,3);
// Recorda posar al HC06 bluetooth RX pin 2 , TX pin 3
  
void setup() {
// Configura els ports motor 1 con eixides
pinMode(contacte1motor1, OUTPUT);
pinMode(contacte2motor1, OUTPUT);
pinMode(activaPWMmotor1, OUTPUT);

// Configura els ports motor 2 con eixides
pinMode(contacte1motor2, OUTPUT);
pinMode(contacte2motor2, OUTPUT);
pinMode(activaPWMmotor2, OUTPUT);
  
  serial.begin(9600); // Monitor bluetooth per connectar amb mòbil
  Serial.begin(9600); // Monitor Serial per comunicar amb l'ordinador
}
 
void loop() {
  // activa el motorA per poder engegar-lo
digitalWrite(activaPWMmotor1, HIGH);
digitalWrite(activaPWMmotor2, HIGH);

  if(serial.available())
  {
    char caracter= serial.read();
    Serial.println(caracter);
   switch(caracter){
  
      case '0':// Cotxe avant, els 2 motors en mode Horari
analogWrite(activaPWMmotor1, escriuPols);//Reduim velocitat M1 al 50%
analogWrite(activaPWMmotor2, escriuPols);//Reduim velocitat M2 al 50%      
digitalWrite(contacte1motor1, LOW); //M1  
digitalWrite(contacte2motor1, HIGH); //M1
digitalWrite(contacte1motor2, LOW); //M2  
digitalWrite(contacte2motor2, HIGH); //M2
        break;
      case '1'://Cotxe enrere, el dos motors en mode antiHorari
analogWrite(activaPWMmotor1, escriuPols);//Reduim velocitat M1 al 50%
analogWrite(activaPWMmotor2, escriuPols);//Reduim velocitat M2 al 50%
digitalWrite(contacte1motor1, HIGH); //M1  
digitalWrite(contacte2motor1, LOW); //M1
digitalWrite(contacte1motor2, HIGH); //M2  
digitalWrite(contacte2motor2, LOW); //M2
        break;
      case '2'://Cotxe gira esquerra, motor 1 H i motor 2 aH
analogWrite(activaPWMmotor1, escriuPols);//Reduim velocitat M1 al 50%
analogWrite(activaPWMmotor2, escriuPols);//Reduim velocitat M2 al 50%
digitalWrite(contacte1motor1,HIGH); //M1  
digitalWrite(contacte2motor1, LOW); //M1
digitalWrite(contacte1motor2, LOW); //M2  
digitalWrite(contacte2motor2, HIGH); //M2
        break;
      case '3'://Cotxe gira dreta, motor 1 aH i motor 2 H
analogWrite(activaPWMmotor1, escriuPols);//Reduim velocitat M1 al 50%
analogWrite(activaPWMmotor2, escriuPols);//Reduim velocitat M2 al 50%
digitalWrite(contacte1motor1, LOW); //M1  
digitalWrite(contacte2motor1, HIGH); //M1
digitalWrite(contacte1motor2, HIGH); //M2  
digitalWrite(contacte2motor2, LOW); //M2
        break;
      case '4'://Cotxe atura motors, motor 1 i motor 2 aturats
analogWrite(activaPWMmotor1, escriuPols);//Reduim velocitat M1 al 50%
analogWrite(activaPWMmotor2, escriuPols);//Reduim velocitat M2 al 50%
digitalWrite(contacte1motor1, LOW); //M1  
digitalWrite(contacte2motor1, LOW); //M1
digitalWrite(contacte1motor2, LOW); //M2  
digitalWrite(contacte2motor2, LOW); //M2
        break;
   }//Final switch 
  } //Final if
 // Ací és pot afegir més codi
 
}// Final void loop
